//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaImageIOReadImages.h"
#include "bbcreaImageIOPackage.h"

#include "creaImageIOSimpleView.h"

namespace bbcreaImageIO
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaImageIO,ReadImages)
BBTK_BLACK_BOX_IMPLEMENTATION(ReadImages,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadImages::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
  	std::vector<vtkImageData*> 							mResults;
	VectorMapInfoDicom 									mResultsDicomAtr;
	creaImageIO::SimpleView 							mView;
  
  	if (bbGetInputActive()==true)
  	{
	  	if( mView.readFile(bbGetInputLstNameImages() , bbGetInputDicomTags() , mResultsDicomAtr , mResults)==true )
	  	{
	  		bbSetOutputOut( mView.getVolumeSelected( mResults ) );
	  		bbSetOutputOutImages( mResults  );
	  		bbSetOutputDicomInfo( mResultsDicomAtr  );
	  	} else {
	  		bbSetOutputOut( NULL );
	  	 	printf("EED Warning! ReadImages::Process   Files(s) not found. \n");
	  	}// if readFile
  	} else {
	  		bbSetOutputOutImages( mResults  );
	  		bbSetOutputDicomInfo( mResultsDicomAtr  );
	  		bbSetOutputOut( NULL );  	
  	}//Active	
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadImages::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputActive(true);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadImages::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadImages::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaImageIO


